package dev.shadowsoffire.apotheosis.ench.anvil;

import dev.shadowsoffire.apotheosis.advancements.AdvancementTriggers;
import net.minecraft.world.entity.EntitySelector;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.nbt.Tag;
import net.minecraft.world.entity.Entity;
import net.minecraft.nbt.ListTag;
import java.util.Iterator;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.item.EnchantedBookItem;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.Enchantments;
import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.entity.item.FallingBlockEntity;
import net.minecraft.util.RandomSource;
import net.minecraft.server.level.ServerLevel;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.phys.HitResult;
import java.util.function.Function;
import java.util.stream.Collectors;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import net.minecraft.world.level.ItemLike;
import java.util.List;
import net.minecraft.world.level.storage.loot.LootParams;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Map;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.material.PushReaction;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.EntityBlock;
import dev.shadowsoffire.apotheosis.util.INBTSensitiveFallingBlock;
import net.minecraft.world.level.block.AnvilBlock;

public class ApothAnvilBlock extends AnvilBlock implements INBTSensitiveFallingBlock, EntityBlock
{
    public ApothAnvilBlock() {
        super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283906_).m_278166_(PushReaction.BLOCK).m_60999_().m_60913_(5.0f, 1200.0f).m_60918_(SoundType.f_56749_));
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return new AnvilTile(pPos, pState);
    }
    
    public void m_6402_(final Level world, final BlockPos pos, final BlockState state, final LivingEntity placer, final ItemStack stack) {
        final BlockEntity te = world.m_7702_(pos);
        if (te instanceof final AnvilTile anvil) {
            final Map<Enchantment, Integer> ench = EnchantmentHelper.m_44831_(stack);
            ench.keySet().removeIf(e -> !this.m_5456_().canApplyAtEnchantingTable(stack, e));
            anvil.getEnchantments().putAll((Map)ench);
        }
    }
    
    public List<ItemStack> m_49635_(final BlockState state, final LootParams.Builder builder) {
        final ItemStack anvil = new ItemStack((ItemLike)this);
        final Object 287261_ = builder.m_287261_(LootContextParams.f_81462_);
        if (287261_ instanceof final AnvilTile te) {
            Map<Enchantment, Integer> ench = (Map<Enchantment, Integer>)te.getEnchantments();
            ench = ench.entrySet().stream().filter(e -> e.getValue() > 0).collect(Collectors.toMap((Function<? super Object, ? extends Enchantment>)Map.Entry::getKey, (Function<? super Object, ? extends Integer>)Map.Entry::getValue));
            EnchantmentHelper.m_44865_((Map)ench, anvil);
        }
        return List.of(anvil);
    }
    
    public ItemStack getCloneItemStack(final BlockState state, final HitResult target, final BlockGetter world, final BlockPos pos, final Player player) {
        final ItemStack anvil = new ItemStack((ItemLike)this);
        final BlockEntity te = world.m_7702_(pos);
        if (te instanceof final AnvilTile anvilTile) {
            Map<Enchantment, Integer> ench = (Map<Enchantment, Integer>)anvilTile.getEnchantments();
            ench = ench.entrySet().stream().filter(e -> e.getValue() > 0).collect(Collectors.toMap((Function<? super Object, ? extends Enchantment>)Map.Entry::getKey, (Function<? super Object, ? extends Integer>)Map.Entry::getValue));
            EnchantmentHelper.m_44865_((Map)ench, anvil);
        }
        return anvil;
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_5871_(final ItemStack stack, final BlockGetter world, final List<Component> tooltip, final TooltipFlag flagIn) {
        if (!stack.m_41790_()) {
            tooltip.add((Component)Component.m_237115_("info.apotheosis.anvil").m_130940_(ChatFormatting.GRAY));
        }
    }
    
    public void m_6810_(final BlockState state, final Level world, final BlockPos pos, final BlockState newState, final boolean isMoving) {
        if (!((BlockEntityType)Apoth.Tiles.ANVIL.get()).m_155262_(newState)) {
            world.m_46747_(pos);
        }
    }
    
    public void m_213897_(final BlockState pState, final ServerLevel pLevel, final BlockPos pPos, final RandomSource pRand) {
        if (m_53241_(pLevel.m_8055_(pPos.m_7495_())) && pPos.m_123342_() >= pLevel.m_141937_()) {
            final BlockEntity be = pLevel.m_7702_(pPos);
            final FallingBlockEntity e = FallingBlockEntity.m_201971_((Level)pLevel, pPos, pState);
            if (be instanceof final AnvilTile anvil) {
                anvil.m_183515_(e.f_31944_ = new CompoundTag());
            }
            this.m_6788_(e);
        }
    }
    
    public void m_48792_(final Level world, final BlockPos pos, final BlockState fallState, final BlockState hitState, final FallingBlockEntity anvil) {
        super.m_48792_(world, pos, fallState, hitState, anvil);
        final List<ItemEntity> items = world.m_45976_((Class)ItemEntity.class, new AABB(pos, pos.m_7918_(1, 1, 1)));
        if (anvil.f_31944_ == null) {
            return;
        }
        final Map<Enchantment, Integer> enchantments = EnchantmentHelper.m_44882_(anvil.f_31944_.m_128437_("enchantments", 10));
        final int oblit = enchantments.getOrDefault(Ench.Enchantments.OBLITERATION.get(), 0);
        final int split = enchantments.getOrDefault(Ench.Enchantments.SPLITTING.get(), 0);
        final int ub = enchantments.getOrDefault(Enchantments.f_44986_, 0);
        if (split > 0 || oblit > 0) {
            for (final ItemEntity entity : items) {
                final ItemStack stack = entity.m_32055_();
                if (stack.m_41720_() == Items.f_42690_) {
                    final ListTag enchants = EnchantedBookItem.m_41163_(stack);
                    boolean handled = false;
                    if (enchants.size() == 1 && oblit > 0) {
                        handled = this.handleObliteration(world, pos, entity, enchants);
                    }
                    else if (enchants.size() > 1 && split > 0) {
                        handled = this.handleSplitting(world, pos, entity, enchants);
                    }
                    if (!handled) {
                        continue;
                    }
                    if (world.f_46441_.m_188503_(1 + ub) == 0) {
                        final BlockState dmg = m_48824_(fallState);
                        if (dmg == null) {
                            world.m_46597_(pos, Blocks.f_50016_.m_49966_());
                            world.m_46796_(1029, pos, 0);
                        }
                        else {
                            world.m_46597_(pos, dmg);
                        }
                        break;
                    }
                    break;
                }
            }
        }
    }
    
    protected boolean handleSplitting(final Level world, final BlockPos pos, final ItemEntity entity, final ListTag enchants) {
        entity.m_142687_(Entity.RemovalReason.DISCARDED);
        for (final Tag nbt : enchants) {
            final CompoundTag tag = (CompoundTag)nbt;
            final int level = tag.m_128451_("lvl");
            final Enchantment enchant = (Enchantment)ForgeRegistries.ENCHANTMENTS.getValue(new ResourceLocation(tag.m_128461_("id")));
            if (enchant == null) {
                continue;
            }
            final ItemStack book = EnchantedBookItem.m_41161_(new EnchantmentInstance(enchant, level));
            Block.m_49840_(world, pos.m_7494_(), book);
        }
        world.m_6443_((Class)ServerPlayer.class, new AABB(pos).m_82377_(5.0, 5.0, 5.0), EntitySelector.f_20408_).forEach(p -> AdvancementTriggers.SPLIT_BOOK.trigger(p.m_8960_()));
        return true;
    }
    
    protected boolean handleObliteration(final Level world, final BlockPos pos, final ItemEntity entity, final ListTag enchants) {
        final CompoundTag nbt = enchants.m_128728_(0);
        final int level = nbt.m_128451_("lvl") - 1;
        if (level <= 0) {
            return false;
        }
        final Enchantment enchant = (Enchantment)ForgeRegistries.ENCHANTMENTS.getValue(new ResourceLocation(nbt.m_128461_("id")));
        if (enchant == null) {
            return false;
        }
        final ItemStack book = EnchantedBookItem.m_41161_(new EnchantmentInstance(enchant, level));
        entity.m_142687_(Entity.RemovalReason.DISCARDED);
        Block.m_49840_(world, pos.m_7494_(), book);
        Block.m_49840_(world, pos.m_7494_(), book.m_41777_());
        return true;
    }
    
    public ItemStack toStack(final BlockState state, final CompoundTag tag) {
        final ItemStack anvil = new ItemStack((ItemLike)this);
        Map<Enchantment, Integer> ench = EnchantmentHelper.m_44882_(tag.m_128437_("enchantments", 10));
        ench = ench.entrySet().stream().filter(e -> e.getValue() > 0).collect(Collectors.toMap((Function<? super Object, ? extends Enchantment>)Map.Entry::getKey, (Function<? super Object, ? extends Integer>)Map.Entry::getValue));
        EnchantmentHelper.m_44865_((Map)ench, anvil);
        return anvil;
    }
}
